'BA presentation should have a variable called scrollrate with sane Default values ranging from 20000-100000 

Function Custom_Initialize(msgPort As Object, userVariables As Object, bsp as Object)

    print "Custom_Initialize - entry"
    print "type of msgPort is ";type(msgPort)
    print "type of userVariables is ";type(userVariables)

    Custom = newCustom(msgPort, userVariables, bsp)

    return Custom

End Function


Function newCustom(msgPort As Object, userVariables As Object, bsp as Object)
	print "initCustom"

	' Create the object to return and set it up
	s = {}
	s.msgPort = msgPort
	s.userVariables = userVariables
	s.bsp = bsp
	s.ProcessEvent = Custom_ProcessEvent
	s.HandlePluginTimerEvent = HandlePluginTimerEvent
	s.Enabled = false
	
	s.systemTime = CreateObject("roSystemTime")
	s.mytimer = CreateObject("roTimer")
	s.newTimeout = s.systemTime.GetLocalDateTime()
	s.newTimeout.AddMilliSeconds(1000)
	s.mytimer.SetDateTime(s.newTimeout)
	s.mytimer.SetPort(s.msgPort)
	s.mytimer.Start()
	
	's.tickerSpeed = 80000
	
	s.tickerSpeed = val(s.uservariables.scrollrate.currentvalue$)
	
	s.objectName = "Custom_object"
	
	return s
End Function

Function Custom_ProcessEvent(event As Object) as boolean

	retval = false
    print "Custom_ProcessEvent - entry"
    print "type of m is ";type(m)
    print "type of event is ";type(event)

	if type(event) = "roTimerEvent" then
		retval = HandlePluginTimerEvent(event, m)
	end if

	return retval

End Function





Function HandlePluginTimerEvent(origMsg as Object, Custom as object) as boolean

	if type(origMsg) = "roTimerEvent" then
	
		timerIdentity = origMsg.GetSourceIdentity()
		
		'stop
		
		'print "$$$$$ timer message received from HandleTimerEvent: $$$$$$ "; stri(timerIdentity)
		
		if Custom.mytimer.GetIdentity() = timerIdentity then
				
			numZones% = custom.bsp.sign.zoneshsm.Count()
			
			if numZones% > 0 then
				for i% = 0 to numZones% - 1
		
					SetScrollSpeedforTicker = Custom.bsp.sign.zoneshsm[i%].widget
						
					if SetScrollSpeedforTicker <> invalid then
				
						if Custom.Enabled = false then
						
							SetScrollSpeedforTicker.SetAnimationSpeed(Custom.tickerSpeed)
							'Custom.bsp.sign.zoneshsm[1].widget.SetAnimationSpeed(Custom.tickerSpeed)
							Custom.Enabled = true
						
							print "$$$$$ Ticker speed scroll set to: $$$$$$ "; stri(Custom.tickerSpeed)				
							
						end if
						
					end if
				
				next
			end if	
		
		end if
		

	
	end if


End Function







